﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpertatorÖverlagring;

namespace OperatorÖverlagring.Test
{
    [TestClass]
    public class CardTest
    {
        [TestMethod]
        public void SameSuitAndValueShouldEqual()
        {
            var card1 = new Card(CardSuit.Hearts, CardValue.King);
            var card2 = new Card(CardSuit.Hearts, CardValue.King);

            Assert.AreEqual(card1, card2);
            Assert.IsTrue(card1 == card2);
        }

        [TestMethod]
        public void SameSuitDifferentValuesShouldNotEqual()
        {
            var card1 = new Card(CardSuit.Hearts, CardValue.King);
            var card2 = new Card(CardSuit.Hearts, CardValue.Queen);

            Assert.AreNotEqual(card1, card2);
            Assert.IsTrue(card1 != card2);
        }

        [TestMethod]
        public void DifferentSuitsSameValueShouldNotEqual()
        {
            var card1 = new Card(CardSuit.Hearts, CardValue.King);
            var card2 = new Card(CardSuit.Spades, CardValue.King);

            Assert.AreNotEqual(card1, card2);
            Assert.IsTrue(card1 != card2);
        }

    }
}
