﻿namespace OpertatorÖverlagring
{
    public struct Card
    {
        public Card(CardSuit suit, CardValue value)
        {
            Suit = suit;
            Value = value;
        }

        public readonly CardSuit Suit;
        public readonly CardValue Value;

        #region Equals

        public override bool Equals(object obj)
        {
            if (obj is Card) return this.Equals((Card)obj);
            else return false;
        }

        public bool Equals(Card other)
        {
            return ((this.Suit == other.Suit) && (this.Value == other.Value));
        }

        public override int GetHashCode()
        {
            return Suit.GetHashCode() ^ Value.GetHashCode();
        }

        #endregion

        #region Operators

        public static bool operator ==(Card value1, Card value2)
        {
            return value1.Equals(value2);
        }

        public static bool operator !=(Card value1, Card value2)
        {
            return !value1.Equals(value2);
        }

        #endregion
    }

    public enum CardSuit
    {
        Clubs = 0,
        Diamonds = 1,
        Hearts = 2,
        Spades = 3
    }
    public enum CardValue
    {
        Ace = 1,
        Deuce = 2,
        Three = 3,
        Four = 4,
        Five = 5,
        Six = 6,
        Seven = 7,
        Eight = 8,
        Nine = 9,
        Ten = 10,
        Jack = 11,
        Queen = 12,
        King = 13
    }
}
